import json
from datetime import datetime
from app.logs.models import LogsTimeline, AlertHistory
from app import db
def add_alert_logs_timeline(alert_id, id, status, user_name, note, user_id):
    new_alert_timeline = LogsTimeline(alert_id=id, status=status, user_name=user_name, note=note)
    db.session.add(new_alert_timeline)
    db.session.flush()
    append_data_in_alert_history(user_name, alert_id, status, note, "", new_alert_timeline, user_id)
    db.session.commit()
def add_log_history(call_action, device, room, site, zone_name, patient, name, room_name, alert_log_history,
                    first_timeline_entry, flag, id, logo_id):
    try:
        alert_history = {
            "alert_id": alert_log_history.id,
            "site_id": device.site_id,
            "zone_id": room.zone_id,
            "alert_log_array": construct_data(call_action, device, patient, name,
                                              room_name, site, zone_name, room, id, logo_id),
            "alert_log_timeline": json.dumps(construct_timeline(first_timeline_entry)),
            "patient_or_staff_id": flag }
        first_alert_history = AlertHistory(**alert_history)
        db.session.add(first_alert_history)
        db.session.commit()
    except Exception as e:
        print(f"Error: {e}")

def construct_data(call_action, device, patient, name, room_name, site, zone_name, room, id, logo_id):
    return json.dumps({
        "alert_type": call_action,
        "device_mac": device.device_mac_address,
        "device_name": device.device_name,
        "first_name": "",
        "last_name": "",
        "note": "",
        "patient_name": patient.patient_name if patient else name,
        "room_name": room_name,
        "user_name": "",
        "site_name": site.site_name,
        "zone_name": zone_name,
        "zone_id": room.zone_id,
        "room_id": device.room_id,
        "device_id": device.device_id,
        "patient_id": id,
        "logo_id": logo_id })
def construct_timeline(first_timeline_entry):
    return [
        {
            "user_name": first_timeline_entry.user_name,
            "status": first_timeline_entry.status,
            "note": first_timeline_entry.note,
            "alert_type": first_timeline_entry.alert_type,
            "created_at_date_details": first_timeline_entry.created_at.strftime("%d %b %Y"),
            "created_at_time_details": first_timeline_entry.created_at.strftime("%I:%M:%S %p")
        }]
def append_data_in_alert_history(user_name, alert_id, status, note, alert_type, alert_timeline, user_id):
    alert_history = AlertHistory.query.filter_by(alert_id=alert_id).first()
    if alert_history:
        history_data = json.loads(alert_history.alert_log_timeline)
        if alert_type:
            alert_log_array = json.loads(alert_history.alert_log_array)
            if alert_log_array['alert_type'] == alert_type:
                status = "Repeat"
            alert_log_array['alert_type'] = alert_type
            alert_history.alert_log_array = json.dumps(alert_log_array)
        new_entry = {
            "first_name": user_name,
            "status": status,
            "note": note,
            "alert_type": alert_type,
            "created_at_date_details": alert_timeline.created_at.strftime("%d %b %Y"),
            "created_at_time_details": alert_timeline.created_at.strftime("%I:%M:%S %p")}
        alert_history.user_id = user_id
        history_data.append(new_entry)
        alert_history.alert_log_timeline = json.dumps(history_data)
        db.session.commit()
    else:
        print(f"No alert history found for alert_id: {alert_id}")
def stringify_dates(from_date, to_date):
    return datetime.strptime(f'{from_date} 00:00:00', '%Y-%m-%d %H:%M:%S'), datetime.strptime(
        f'{to_date} 23:59:59', '%Y-%m-%d %H:%M:%S')